VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.activevb.de"
   ClientHeight    =   6600
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6360
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6600
   ScaleWidth      =   6360
   StartUpPosition =   3  'Windows-Standard
   Begin VB.HScrollBar HScroll4 
      Height          =   255
      LargeChange     =   500
      Left            =   120
      Max             =   86
      TabIndex        =   5
      Top             =   6240
      Value           =   45
      Width           =   6045
   End
   Begin VB.HScrollBar HScroll3 
      Height          =   255
      LargeChange     =   500
      Left            =   120
      Max             =   180
      Min             =   -180
      TabIndex        =   4
      Top             =   5880
      Width           =   6045
   End
   Begin VB.HScrollBar HScroll2 
      Height          =   255
      LargeChange     =   500
      Left            =   120
      Max             =   180
      Min             =   -180
      TabIndex        =   3
      Top             =   5520
      Width           =   6045
   End
   Begin VB.PictureBox ps 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   3960
      Left            =   2040
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   260
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   113
      TabIndex        =   2
      Top             =   720
      Visible         =   0   'False
      Width           =   1755
   End
   Begin VB.PictureBox pd 
      AutoSize        =   -1  'True
      Height          =   4560
      Left            =   120
      ScaleHeight     =   300
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   400
      TabIndex        =   1
      Top             =   360
      Width           =   6060
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   500
      Left            =   120
      Max             =   180
      Min             =   -180
      TabIndex        =   0
      Top             =   5160
      Width           =   6045
   End
   Begin VB.PictureBox po 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   4560
      Left            =   0
      ScaleHeight     =   300
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   400
      TabIndex        =   6
      Top             =   0
      Visible         =   0   'False
      Width           =   6060
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit
'Source von Daniel Aue

Const pi180 = 3.14159265358979 / 180

Private Declare Function PlgBlt Lib "gdi32.dll" ( _
         ByVal hdcDest As Long, _
         lpPoint As POINTAPI, _
         ByVal hdcSrc As Long, _
         ByVal nXSrc As Long, _
         ByVal nYSrc As Long, _
         ByVal nWidth As Long, _
         ByVal nHeight As Long, _
         ByVal hbmMask As Long, _
         ByVal xMask As Long, _
         ByVal yMask As Long) As Long

Private Type POINTAPI
        x As Long
        y As Long
End Type

Dim PtList(2) As POINTAPI

Private Sub Form_Load()
    pd.Picture = LoadPicture(App.Path & "\back.jpg")
    po.Picture = LoadPicture(App.Path & "\back.jpg")
    DoRedraw
End Sub

Private Sub HScroll1_Change()
    DoRedraw
End Sub

Private Sub HScroll2_Change()
    DoRedraw
End Sub

Private Sub HScroll3_Change()
    DoRedraw
End Sub

Private Sub HScroll4_Change()
    DoRedraw
End Sub

Private Sub HScroll1_Scroll()
    DoRedraw
End Sub

Private Sub HScroll2_Scroll()
    DoRedraw
End Sub

Private Sub HScroll3_Scroll()
    DoRedraw
End Sub

Private Sub HScroll4_Scroll()
    DoRedraw
End Sub

Sub DoRedraw()
    Dim x As Integer
    Dim NewX As Integer, NewY As Integer
    Dim SinAng1, CosAng1, SinAng2, SinAng3
    Dim Zoom

    'Punktliste zurcksetzen:
    PtList(0).x = -(ps.ScaleWidth / 2)
    PtList(0).y = -(ps.ScaleHeight / 2)
    PtList(1).x = ps.ScaleWidth / 2
    PtList(1).y = -(ps.ScaleHeight / 2)
    PtList(2).x = -(ps.ScaleWidth / 2)
    PtList(2).y = (ps.ScaleHeight / 2)
    
    'Variablen vorberechnen:
    Zoom = Tan(HScroll4.Value * pi180)
    SinAng1 = Sin((HScroll1.Value + 90) * pi180)
    CosAng1 = Cos((HScroll1.Value + 90) * pi180)
    SinAng2 = Sin((HScroll2.Value + 90) * pi180) * Zoom
    SinAng3 = Sin((HScroll3.Value + 90) * pi180) * Zoom
    
    'Punkte transformieren:
    For x = 0 To 2
        NewX = (PtList(x).x * SinAng1 + PtList(x).y * CosAng1) * SinAng2
        NewY = (PtList(x).y * SinAng1 - PtList(x).x * CosAng1) * SinAng3
        PtList(x).x = NewX + (pd.ScaleWidth / 2)
        PtList(x).y = NewY + (pd.ScaleHeight / 2)
    Next
    
    'alte Darstellung des Back Buffers lschen
    po.Cls
    
    'neue Darstellung in den Backbuffer zeichnen:
    Call PlgBlt(po.hDC, PtList(0), ps.hDC, 0, 0, ps.ScaleWidth, ps.ScaleHeight, 0, 0, 0)
    
    'und in die Anzeige PicBox bernehmen:
    pd.Picture = po.Image
End Sub
